# Jobs that are generally only executable by CI and not locally.
#
.verify-job:
  stage: verify
  extends: .rules:code-changes
  tags:
    - gitlab-org
    - high-cpu
  needs:
    - release-image
    - verify-start
  artifacts:
    paths:
      - ./gdk/gitlab/log/*.log
      - ./gdk/log
      - ./gdk/sv/*/run
    expire_in: 2 days
    when: always
  variables:
    GEM_HOME: "$CI_PROJECT_DIR/.gem"
    GEM_PATH: "$CI_PROJECT_DIR/.gem"
    GOCACHE: "$CI_PROJECT_DIR/.cache/go-build"
    GOMODCACHE: "$CI_PROJECT_DIR/.cache/go-mod"
  cache:
    - key:
        files:
          - '.ruby-version'
          - '.gitlab/ci/verify.gitlab-ci.yml'
      paths:
        - "$CI_PROJECT_DIR/.gem"
      policy: pull-push
    - key:
        files:
          - '.tool-versions'
      paths:
        - "$CI_PROJECT_DIR/.cache/go-build"
        - "$CI_PROJECT_DIR/.cache/go-mod"
      policy: pull-push

verify-start:
  stage: pre-verify
  image: alpine:edge
  interruptible: false
  needs: []
  variables:
    GIT_STRATEGY: none
  script:
    - echo "This job exists to allow all other verify:* jobs to be started manually"
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH || $CI_COMMIT_TAG
      when: always
    - when: manual
      allow_failure: true

install:
  extends: .verify-job
  script:
    - support/ci/verify-install

install-experimental:
  extends: .verify-job
  script:
    - support/ci/verify-install-experimental

one-line-install:
  extends: .verify-job
  script:
    - support/ci/verify-one-line-install

doctor:
  extends: .verify-job
  script:
    - support/ci/verify-doctor

debug-info:
  extends: .verify-job
  script:
    - bin/gdk debug-info

reconfigure:
  extends: .verify-job
  script:
    - support/ci/verify-reconfigure

reset-data:
  extends: .verify-job
  script:
    - support/ci/verify-reset-data

pristine:
  extends: .verify-job
  script:
    - support/ci/verify-pristine

update-from-default-branch:
  extends: .verify-job
  script:
    - support/ci/verify-update $CI_DEFAULT_BRANCH

update-from-mr-branch:
  extends: .verify-job
  script:
    - support/ci/verify-update

gitpod-docker-image:
  extends:
    - .docker:build-docker-in-docker
    - .rules:gitpod-code-changes
  stage: !reference ['.verify-job', stage]
  needs:
    - build-gitpod-workspace-image
  script:
    - support/ci/verify-gitpod-docker-image
  artifacts:
    paths:
      - ./artifacts/log/*
    expire_in: 2 days
    when: on_failure
  timeout: 1h